
/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SEMAFOROS IPC
FICHERO     : line.h
DESCRIPCION : Cabecera donde se definen las claves de la memoria compartida
y el semaforo.
*/

struct info {
 char c;
 int length;
};

union semun {
 int val;
 struct semid_ds *buf;
 u_short *array;
};

#define KEYSHMEM ((key_t) (1234))
#define KEYSEM	 ((key_t) (4321))
#define SEGSIZE	sizeof(struct info)
#define SEMSIZE 1

void Lock (int, int); // Funcion que realiza wait sobre un elemento del semaforo IPC
void Unlock (int, int);// Funcion que realiza signal sobre un elemento del semaforo IPC
int  InicializaElemento (int, int, int);  // Funcion que inicializa un elemento un semaforo IPC a un valor
		
